# Record Class CATypePackage

java.lang.Object
java.lang.Record
com.io7m.cardant.model.type_package.CATypePackage

Record Components:
  `identifier` - The package identifier
  `description` - The package description
  `imports` - The packages this package imports
  `scalarTypes` - The scalar types
  `recordTypes` - The record types

public record CATypePackage(CATypePackageIdentifier identifier, String description, Set<CATypePackageImport> imports, Map<CATypeScalarIdentifier, CATypeScalarType> scalarTypes, Map<CATypeRecordIdentifier, CATypeRecord> recordTypes) extends Record
A type package.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CATypePackage(CATypePackageIdentifier identifier, String description, Set<CATypePackageImport> imports, Map<CATypeScalarIdentifier, CATypeScalarType> scalarTypes, Map<CATypeRecordIdentifier, CATypeRecord> recordTypes)`
  A type package.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `CATypePackageIdentifier`
  `identifier()`
  Returns the value of the `identifier` record component.
  `Set<CATypePackageImport>`
  `imports()`
  Returns the value of the `imports` record component.
  `Map<CATypeRecordIdentifier, CATypeRecord>`
  `recordTypes()`
  Returns the value of the `recordTypes` record component.
  `Map<CATypeScalarIdentifier, CATypeScalarType>`
  `scalarTypes()`
  Returns the value of the `scalarTypes` record component.
  `CATypePackageSummary`
  `summary()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CATypePackage

    public CATypePackage(CATypePackageIdentifier identifier, String description, Set<CATypePackageImport> imports, Map<CATypeScalarIdentifier, CATypeScalarType> scalarTypes, Map<CATypeRecordIdentifier, CATypeRecord> recordTypes)
    A type package.
    Parameters:
      `identifier` - The package identifier
      `description` - The package description
      `imports` - The packages this package imports
      `scalarTypes` - The scalar types
      `recordTypes` - The record types

- ## Method Details

  - ### summary

    public CATypePackageSummary summary()
    Returns:
      A summary of this package

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### identifier

    public CATypePackageIdentifier identifier()
    Returns the value of the `identifier` record component.
    Returns:
      the value of the `identifier` record component

  - ### description

    public String description()
    Returns the value of the `description` record component.
    Returns:
      the value of the `description` record component

  - ### imports

    public Set<CATypePackageImport> imports()
    Returns the value of the `imports` record component.
    Returns:
      the value of the `imports` record component

  - ### scalarTypes

    public Map<CATypeScalarIdentifier, CATypeScalarType> scalarTypes()
    Returns the value of the `scalarTypes` record component.
    Returns:
      the value of the `scalarTypes` record component

  - ### recordTypes

    public Map<CATypeRecordIdentifier, CATypeRecord> recordTypes()
    Returns the value of the `recordTypes` record component.
    Returns:
      the value of the `recordTypes` record component